#include <Keypad.h>
#include "pitches.h"
#define laser 5
int sensorPin = A1;

unsigned long P = millis();

//ULTRASON
const int trigPin = 4;
const int echoPin = 3;
const int buzPin  = 2;

//ULTRASON


//KEYPAD
const int ROW_NUM = 4; //four rows
const int COLUMN_NUM = 3; //three columns

char keys[ROW_NUM][COLUMN_NUM] = {
  {'1','2','3'},
  {'4','5','6'},
  {'7','8','9'},
  {'*','0','#'}
};

byte pin_rows[ROW_NUM] = {6,7,8,9}; //connect to the row pinouts of the keypad
byte pin_column[COLUMN_NUM] = {10,11,12}; //connect to the column pinouts of the keypad

Keypad keypad = Keypad( makeKeymap(keys), pin_rows, pin_column, ROW_NUM, COLUMN_NUM );
String input_password;
//KEYPAD

//TIMERS
int T1 = 10000;
int T2 = 10000;
int T3 = 5000;
int T4 = 10000;
unsigned long P1 = millis();
unsigned long P2 = millis();
unsigned long P3 = millis();
unsigned long P4 = millis();
//TIMERS
int nbr_jeux = 0;


void setup() {
  Serial.begin(9600);
  randomSeed(analogRead(A0)); 

  pinMode(trigPin, OUTPUT); // Sets the trigPin as an Output
  pinMode(echoPin, INPUT); // Sets the echoPin as an Input
  Serial.begin(9600); // Starts the serial communication
  pinMode(13, OUTPUT);
  pinMode(12, OUTPUT);
  pinMode(11, OUTPUT);
  pinMode(10, OUTPUT);
  pinMode(laser, OUTPUT);
  input_password.reserve(4);
  pinMode(trigPin, OUTPUT); // Le trig en sortie.
  pinMode(echoPin, INPUT);
  Serial.println("=============================================");
  Serial.println("             WELCOME TO THE");
  Serial.println("R \xF0\x9F\x83\x8A O \xE2\x99\xA3\xEF\xB8\x8F Y \xE2\x99\xA5\xEF\xB8\x8F A \xE2\x99\xA0\xEF\xB8\x8F L \xE2\x99\xA6\xEF\xB8\x8F  F \xE2\x99\xA0\xEF\xB8\x8F L \xE2\x99\xA6\xEF\xB8\x8F U \xE2\x99\xA5\xEF\xB8\x8F S \xE2\x99\xA3\xEF\xB8\x8F H \xF0\x9F\x83\x8A");
  Serial.println("                CASINO");
  Serial.println("=============================================");
  delay(6000);

}

void loop() {
  int i = random(1,4);
  int pwd=random(1000,9999);
  String pswd = String(pwd);
  String password = pswd; // change your password here

  
  
  int wr = random(1,20);
  long duration;
  int distance;

  if (i==1){
    Serial.println("Starting the xenon laser process...");
    delay(2000);
    while(i==1){
      digitalWrite(laser,1);
      int sensorValue = analogRead(sensorPin);
      Serial.println(sensorValue);

      if (sensorValue > 900){
        Serial.println("Congratulations, test passed!");
        Serial.println("=============================================");
        nbr_jeux+=1;
        playPassed();
        i = random(1,4);
        while (i==1){
          i = random(1,4);
        }
      }
    }


  }

  else if (i==2){
    
    
    Serial.println((String)"The nuclear code to enter is:"+pswd);
    while(i==2){
      char key = keypad.getKey();
      if (key){
        Serial.print(key);

        if(key == '*') {
          input_password = ""; 
        } else if(key == '#') {
          if(password == input_password) {
            Serial.println("Password correct!");
            Serial.println("=============================================");
            nbr_jeux+=1;
            i = random(1,4);
            while (i==2){
            i = random(1,4);
            
            }
            
            } else {
              Serial.println("password is incorrect, try again");
            }

        } else {
          input_password += key; 
        }
      }
    }

  }

  else if (i==3){
    Serial.println((String)"La distance demandée est: "+wr+"cm");
    delay(6000);
    while (i==3){
    digitalWrite(trigPin, LOW);
      delayMicroseconds(2);
      digitalWrite(trigPin, HIGH);
      delayMicroseconds(10);
      digitalWrite(trigPin, LOW);
      duration = pulseIn(echoPin, HIGH);
      
      distance = (duration/2) / 29.1;

      Serial.print(distance);
      Serial.println(" cm");

      if (distance == wr){
        Serial.println("Congrats, distance reached!!");
        playPassed();
        Serial.println("=============================================");
        nbr_jeux+=1;
        while (i==3){
          i = random(1,4);
        }
      } 
    }

  }

  else if (i==4){
    unsigned long C4 = millis();
    
    Serial.println((String)"Il vous reste "+(T4-C4)/1000+" secondes!");
    

    if((T4-C4)/1000)
      
      

    
    
    C4=T4;
  }


  else if (i==5){
    unsigned long C4 = millis();
    
    Serial.println((String)"Il vous reste "+(T4-C4)/1000+" secondes!");
    

    if((T4-C4)/1000)
      
      

    
    
    C4=T4;
  }


  else if (i==6){
    unsigned long C4 = millis();
    
    Serial.println((String)"Il vous reste "+(T4-C4)/1000+" secondes!");
    

    if((T4-C4)/1000)
      
      

    
    
    C4=T4;
  }
  if (nbr_jeux==5){
    Serial.println("CONGRATS YOUVE WON 1939551945 $$$");
    return;
  }
}

void playPassed() { /* function playPassed */
  ////Play 'ON' Sound
  int melodyOn[] = {NOTE_C5, NOTE_C6, NOTE_D5, NOTE_A6};
  int durationOn = 200;
  for (int thisNote = 0; thisNote < 4; thisNote++) {
    tone(buzPin, melodyOn[thisNote], durationOn);
    delay(200);
  }
}

void playFailed() { /* function playFailed */
  ////Play 'OFF' Sound
  int melodyOff[] = {NOTE_C3, NOTE_D3};
  int durationOff = 200;
  for (int thisNote = 0; thisNote < 2; thisNote++) {
    tone(buzPin, melodyOff[thisNote], durationOff);
    delay(200);
  }
}